Description

This ticket will list problems identified when attempting to build larsoft with e17 (gcc 7.3.0).
All work is on branch feature/team_for_e17

larreco/RecoAlg/KalmanFilterAlg.cxx

[ 10%] Building CXX object larreco/larreco/RecoAlg/CMakeFiles/larreco_RecoAlg.dir/KalmanFilterAlg.
CXX.0

/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/RecoAlg/KalmanFilterAlg.cxx: In mem
ber function ‘bool trkf::KalmanFilterAlg::fitMomentumMS (const trkf::KGTracké&, const trkf::Propagat
or*, trkf::KETracké&) const’:
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/RecoAlg/KalmanFilterAlg.cxx:165:28:
error: ‘vtemp2.boost::numeric::ublas::bounded_array<double, 2, std::allocator<double> >::data_[1]
’ may be used uninitialized in this function [-Werror=maybe-uninitialized]

trkf::KVector<2>::type vtemp2 = prod(templ, vtempl);

cclplus: all warnings being treated as errors

[ 10%] Building CXX object larreco/larreco/RecoAlg/CMakeFiles/larreco_RecoAlg.dir/SeedFinderAlgori
thm.cxx.o
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/RecoRAlg/SeedFinderAlgorithm.cxx: In
member function ‘void trkf::SeedFinderAlgorithm::ConsolidateSeed (recob: :Seed&, const art::PtrVect
or<recob::Hit>&, std::vector<char>&, std::vector<std::vector<std::vector<int> > >&, bool)’:
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/RecoAlg/SeedFinderAlgorithm.cxx:566
:28: error: ‘Occupancy[0]’ may be used uninitialized in this function [-Werror=maybe-uninitialized
]

if (Occupancy[n] < fOccupancyCut) nBelowCut++;

larsim/LArG4/NestAlg.cxx

[ 21%] Building CXX object larsim/larsim/LArG4/CMakeFiles/larsim_LArG4.dir/NestAlg.cxX.o
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larsim/larsim/LArG4/NestAlg.cxx: In member function

‘const G4VParticleChange& NestAlg::CalculateIonizationAndScintillation (const G4Tracké&, const G4St
epé&) '

/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larsim/larsim/LArG4/NestAlg.cxx:12:14: error: ‘*’ 1
n boolean context, suggest ‘&&’ instead [-Werror=int-in-bool-context]

#define WIN O*CLHEP::mm //top Cu block (also, quartz window)
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larsim/larsim/LArG4/NestAlg.cxx:200:9: note: in exp
ansion of macro ‘WIN’

if ( 'WIN && !TOP && !ANE && !SRF && !GAT && !CTH && !BOT && !'PMT )

A

cclplus: all warnings being treated as errors

larreco/ShowerFinder/ShowerReco3D/ShowerRecoAlgBase.cxx

[ 30%] Building CXX object larreco/larreco/ShowerFinder/ShowerReco3D/CMakeFiles/larreco_ShowerFind
er_ShowerReco3D.dir/ShowerRecoAlgBase.cxx.0
In file included from /home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/ShowerFinder/
ShowerReco3D/ShowerRecoAlgBase.cxx:4:0:
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/ShowerFinder/ShowerReco3D/ShowerRec
oAlgBase.h: In member function ‘virtual void showerreco::ShowerRecoAlgBase: :AppendInputClusters (co
nst std::vector<cluster::ClusterParamsAlg>&)':
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/ShowerFinder/ShowerReco3D/ShowerRec
oAlgBase.h:26:10: error: ‘<anonymous>.showerreco::ShowerCluster_t::angle_2d’ may be used uninitial
ized in this function [-Werror=maybe-uninitialized]

struct ShowerCluster_t {
/home/garren/scratch/larsoft/v06_90_00_rc/srcs/larreco/larreco/ShowerFinder/ShowerReco3D/ShowerRec
oAlgBase.h:26:10: error: ‘<anonymous>.showerreco::ShowerCluster_t::plane_id’ may be used uninitial
ized in this function [-Werror=maybe-uninitialized]
cclplus: all warnings being treated as errors

lardata/test/Utilities/Nestedlterator_test.cc

[ 57%] Building CXX object lardata/test/Utilities/CMakeFiles/NestedIterator_test.dir/NestedIterato

r_test.cc.o

/home/garren/scratch/larsoft/v06_90_00_rc/srcs/lardata/test/Utilities/NestedIterator_test.cc: In f

unction ‘void RunVectorMapTest ()’:

/home/garren/scratch/larsoft/v06_90_00_rc/srcs/lardata/test/Utilities/NestedIterator_test.cc:109:2

2: error: call of overloaded ‘insert (<brace-enclosed initializer list>)’ is ambiguous
data.insert ({0, {}});

In file included from /products/gcc/v7_3_0/Linux64bit+3.10-2.17/include/c++/7.3.0/map:61:0,
from /home/garren/scratch/larsoft/v06_90_00_rc/srcs/lardata/test/Utilities/Nested
Iterator_test.cc:16:
/products/gcc/v7_3_0/Linux64bit+3.10-2.17/include/c++/7.3.0/bits/stl_map.h:621:7: note: candidate:
std: :map<_Key, _Tp, _Compare, _Alloc>::insert_return_type std::map<_Key, _Tp, _Compare, _Alloc>::
insert (std::map<_Key, _Tp, _Compare, _Alloc>::node_type&&) [with _Key = int; _Tp = std::vector<int
>; _Compare = std::less<int>; _Alloc = std::allocator<std::pair<const int, std::vector<int> > >; s
td::map<_Key, _Tp, _Compare, _Alloc>::insert_return_type = std::_Node_insert_return<std::_Rb_tree_
iterator<std::pair<const int, std::vector<int> > >, std::_Node_handle<int, std::pair<const int, st
d::vector<int> >, std::allocator<std::_Rb_tree_node<std::pair<const int, std::vector<int> > > > >
>; std::map<_Key, _Tp, _Compare, _Alloc>::node_type = std::_Node_handle<int, std::pair<const int,
std::vector<int> >, std::allocator<std::_Rb_tree_node<std::pair<const int, std::vector<int> > > >
>]
insert (node_type&& __nh)

/products/gcc/v7_3_0/Linux64bit+3.10-2.17/include/c++/7.3.0/bits/stl_map.h:795:7: note: candidate:

std::pair<typename std::_Rb_tree<_Key, std::pair<const _Key, _Tp>, std::_Selectlst<std::pair<cons
t _Key, _Tp> >, _Compare, typename __gnu_cxx::__alloc_traits<_Allocator>::rebind<std::pair<const _
Key, _Tp> >::other>::iterator, bool> std::map<_Key, _Tp, _Compare, _Alloc>::insert (const value_typ
e&) [with _Key = int; _Tp = std::vector<int>; _Compare = std::less<int>; _Alloc = std::allocator<s
td::pair<const int, std::vector<int> > >; typename std::_Rb_tree<_Key, std::pair<const _Key, _Tp>,

std::_Selectlst<std::pair<const _Key, _Tp> >, _Compare, typename __gnu_cxx::__alloc_traits<_Alloc
ator>::rebind<std::pair<const _Key, _Tp> >::other>::iterator = std::_Rb_tree_iterator<std::pair<co
nst int, std::vector<int> > >; std::map<_Key, _Tp, _Compare, _Alloc>::value_type = std::pair<const

int, std::vector<int> >]

insert (const value_typeé& x)

/products/gcc/v7_3_0/Linux64bit+3.10-2.17/include/c++/7.3.0/bits/stl_map.h:802:7: note: candidate:
std: :pair<typename std::_Rb_tree<_Key, std::pair<const _Key, _Tp>, std::_Selectlst<std::pair<cons
t _Key, _Tp> >, _Compare, typename __gnu_cxx::__alloc_traits<_Allocator>::rebind<std::pair<const _
Key, _Tp> >::other>::iterator, bool> std::map<_Key, _Tp, _Compare, _Alloc>::insert (std::map<_Key,
_Tp, _Compare, _Alloc>::value_type&&) [with _Key = int; _Tp = std::vector<int>; _Compare = std::le

ss<int>; _Alloc = std::allocator<std::pair<const int, std::vector<int> > >; typename std::_Rb_tree
<_Key, std::pair<const _Key, _Tp>, std::_Selectlst<std::pair<const _Key, _Tp> >, _Compare, typenam
e __gnu_cxx::__alloc_traits<_Allocator>::rebind<std::pair<const _Key, _Tp> >::other>::iterator = s
td::_Rb_tree_iterator<std::pair<const int, std::vector<int> > >; std::map<_Key, _Tp, _Compare, _Al
loc>::value_type = std::pair<const int, std::vector<int> >]

insert (value_type&& __x)
History

#1 - 07/23/2018 04:05 PM - Gianluca Petrillo

Lynn Garren wrote:

lardata/test/Utilities/Nestedlterator_test.cc

(-]

Since that is my code, | attempted to reword the line so that GCC might be happier (lardata:e53e208c now in develop).

#2 - 07/23/2018 04:27 PM - Christopher Green
Re: larsim/LArG4/NestAlg.cxx, use: if (WIN == 0) ...

#3 - 07/23/2018 04:38 PM - Lynn Garren

Thanks Chris and Gianluca. | confirm that larsim and lardata now build without complaining. | was also able to run the lardata unit tests successfully.

#4 - 07/24/2018 07:30 PM - Lynn Garren

- Status changed from New to Resolved
Kyle fixed the last remaining problems. The feature/team_for_e17 branch now builds with e17. This is just for larsoft itself.

#5 - 07/26/2018 01:12 PM - Lynn Garren
- % Done changed from 0 to 100
https://cdcvs.fnal.gov/redmine/projects/lardata/repository/revisions/e53e208c8096096037a8e2474ad7d0740594caf9
